/*
	executes a command
	
	T.AL 95
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tos.h>

#if !defined(FMAKE_H)
#include "fmake.h"
#endif
#if !defined(TOOLS_H)
#include "tools.h"
#endif

#define EVAL_DONE 2
#define NO_EVAL   4
#define SOURCE    8
#define TARGET   16
#define ALL      32

int dup_stdout= 0;
int stdout_handle= 0;

void set_stdout(char *fname)
{
	if(!*fname) return;
	
	if(Make_Logsinglefile)
	{
		stdout_handle= (int)Fopen(fname, FO_WRITE); /* append single file */
		Fseek(0, stdout_handle, 2);
	}
	else
		stdout_handle= (int)Fcreate(fname, 0);

	dup_stdout= (int)Fdup(1); /* copier l'cran vers un handle non standard */
	Fforce(1, stdout_handle); /* diriger l'cran vers le fichier */
}


void reset_stdout(void)
{
	if(!dup_stdout) return;
	
	Fforce(1,dup_stdout);	/* remettre l'cran sur l'cran */
	Fclose(stdout_handle);	/* fermer le fichier */
	dup_stdout= 0;
}

/* construit la chaine d'environnement
   si la chaine de commande est trop longue utilise ARGV */
char *set_cmdenv(VAR *env, char *cmdstr)
{
	long len= 0L;
	int cmdlen= 0;
	register char *src, *dst; 
	char *cmdenv;
	VAR *var;
	
	for(var= env; var; var= find_var(NULL, NULL, var->next))
	{
		len+= strlen(var->name);
		if(var->value) len +=strlen(var->value)+2;
	}

	cmdlen= *(int *)cmdstr;		
 	if(cmdlen>125)
	{
		len+= cmdlen + 7; /* strlen("\0ARGV=\0") == 7 */
		/* printf("using extended ARGV argument specification\n"); */
	}

	cmdenv= dst= (char *)malloc(len+1L);

	for(var= env; var; var= find_var(NULL, NULL, var->next))
	{
		/* strcpy(tmp, var->name); */
		for(src= var->name +1; *dst++=*src++; ) ;
				
		/* strcat(tmp, var->value); */
		if(var->value) 
		{
			/* strcat(tmp, "="); */
			*(dst-1)= '=';
			for(src= var->value; *dst++=*src++; ) ;
		}		
		
		/* tmp= tmp + strlen(tmp) +1; */
	}
			
	if(cmdlen>125) 
	{	/* ajoute ARGV = `cmdstr` */
		/* strcpy(tmp, "ARGV="); */
		*dst++= 'A'; *dst++='R'; *dst++= 'G'; *dst++= 'V'; 
		*dst++= '='; 
		*dst++= 0;

		/* strcat(tmp, cmdstr); */
		for(src= cmdstr+2; *src; src++) 
		{
			if(*src==' ')
				*dst++= 0; 
			else
				*dst++=*src;
		}

		/* 1B de decalage, le tos veut la taille sur 1B */
		cmdstr[1]= 127;	/* magic: ligne de commande de 127 octets */
		cmdstr[127]= 0; /* 125 octets reels */
	}

	*dst= 0;	/* marque la fin de l'environnement */
		
	return cmdenv;
}

char *set_cmdstr(ARG *argv)
{
	int len= 0;
	char *tail;
	ARG *arg;
	
	/* determine la longueur de la ligne de commande */
	for(arg= argv; arg; arg= arg->next, len++)
	{
		len+= strlen(arg->name);
		if(arg->value)	len+= strlen(arg->value);
	}

	/* reserve la place pour la ligne de commande */	
	tail= malloc((long)len +2 +1);
	*(int *)tail= len;
	tail[2]= 0;
	/* ajoute les arguments sur la ligne de commande */
	for(arg= argv; arg; arg= arg->next)
	{
		strcat(tail+2, arg->name);
		if(arg->value)	strcat(tail+2, arg->value);
		strcat(tail+2, " ");
	}

	return tail;	
}


/* localise une commande :
	si le chemin d'acces n'est pas fourni
		recherche dans le repertoire courant
		recherche d'un chemin d'acces dans l'environnement de la cible
		(si une variable #path est definie ou #PATH -systeme-)
		-> si les recherches echouent, le fichier n'existe pas

	si le chemin d'acces est fourni
		recherche dans ce repertoire
		-> si la le recherche echoue, le fichier n'existe pas 

	=> si les recherches aboutissent cmdpath est mis  jour 
	pour designer le chemin d'acces complet
*/

int locate_a_cmd(char *cmdpath, VAR *env)
{
	char *tmp;
	VAR *var;
	char path[256];

	/* printf("%ssearching cmd '%s'\n", spaces, cmdpath); */
	if(strchr(cmdpath, '\\'))
	{	/* le chemin d'acces est fourni */
		return (Fsfirst(cmdpath, 0) <0);
	}
	else
	{	/* le chemin d'acces n'est pas fourni */
		if(Fsfirst(cmdpath, 0) <0)
		{	/* pas dans le repertoire courant */
			
			/* recherche d'un path make */
			var= find_var("#path", NULL, env);
			while(var)
			{
				strcpy(path, var->value);
				strcat(path, cmdpath);
				/* printf("%ssearching cmd '%s'\n", spaces, path); */

				if(Fsfirst(path ,0) ==0)
				{
					strcpy(cmdpath, path);

					return 0; /* le fichier existe */
				}
				var= find_var("#path", NULL, var->next);
			}

			/* recherche d'un path systeme */
			var= find_var("#PATH", NULL, env);
			while(var)
			{
				strcpy(path, var->value);
				strcat(path, cmdpath);
				/* printf("%ssearching cmd `%s`\n", spaces, path); */
				
				if(Fsfirst(path ,0) ==0)
				{
					strcpy(cmdpath, path);

					return 0; /* le fichier existe */
				}
				var= find_var("#PATH", NULL, var->next);
			}

			return 1; /* le fichier n'existe pas */
		}
		else
		{	/* fichier dans le repertoire courant */
			tmp= strdup(cmdpath);
			strcpy(cmdpath, Path);
			strcat(cmdpath, tmp);
			free(tmp);

			return 0;
		}
	}
}


/* evalue un argument 
   renvoie 0 pour normal
   TARGET pour le nom de la cible
   SOURCE pour le nom du source
   ALL pour le nom de tous les sources de flist
   NO_EVAL pas d'evaluation possible
   EVAL_DONE evaulation terminee
*/

int eval_arg(char *name, char *value, VAR *env)
{
	int code= 0;
	char *var_start, *tmp, *ext= NULL;
	VAR *var;
	
	if(!name)
	{
		*value= 0;
		return NO_EVAL;
	}

	strcpy(value, name);
	if(var_start= strchr(value, '#'))
	{
		if(tmp= getext(var_start))
		{
			ext= strdup(tmp);
			*tmp= 0;
		}
				
		if(strcmp(var_start, "#target")==0)
			code= TARGET;

		else if(strcmp(var_start, "#source")==0)
			code= SOURCE;

		else if(strcmp(var_start, "#all")==0)
			code= ALL;

		if(code)
		{
			if(tmp)
			{
				*tmp= '.';
				strcpy(var_start, tmp);
			}
			else
				*var_start= 0;
		
			return code;
		}
		else
		{
			var= find_var(var_start, ext, env);
			if(ext) free(ext);
			if(!var) return FATAL;
			strcpy(var_start, var->value);
		}
	}

	return EVAL_DONE;
}

int exec_cmd(CMD *cmd, File *target, File *source)
{
	int eval, io_redir= 0;
	VAR **envcut;
	ARG *arg, *cmdarg, *argv= NULL;
	char *ext, *cmdstr, *envstr;
	File *file;
	char evalstr[256], cmdpath[256], stdoutpath[256];

	*stdoutpath= 0;
		
	/* ajoute l'environnement tos */
	envcut= add_an_env(target->env, tosenv);
	if(!envcut)
		alert("fmake: target environment is empty, can't exec command\n");

	/* evaluation path de la commande */
	if(eval_arg(cmd->fname, cmdpath, target->env)==FATAL)
	{
		printf("fmake: can't eval filename '%s'\n", cmdpath);
		*envcut= NULL;
		return FATAL;
	}
	if(locate_a_cmd(cmdpath, target->env))
	{
		printf("fmake: can't find command '%s'\n", cmdpath);
		*envcut= NULL;
		return FATAL;
	}

	/* stocke la localisation de la commande */
	free(cmd->fname);
	cmd->fname= strdup(cmdpath);

	/* evaluation de la ligne de commande */
	for(arg= cmd->argv; arg; arg= arg->next)
	{
		eval= eval_arg(arg->name, evalstr, target->env);

		if(*evalstr=='>')
		{
			if(arg->value)
				io_redir= 1;
			strcpy(stdoutpath, evalstr +1);
		}
		
		else if(eval==TARGET)
		{	/* ajoute la cible */
			cmdarg= add_an_arg(&argv, new_arg());
			cmdarg->name= strcatdup(evalstr, target->fname);
		}

		else if(eval==SOURCE)
		{	/* ajoute le source */
			cmdarg= add_an_arg(&argv, new_arg());
			cmdarg->name= strcatdup(evalstr, source->fname);
		}	

		else if(eval==ALL)
			/* ajoute tous les sources */
			for(file= source; file; file= file->next)
			{
				if(!file->dependency)
				{
					cmdarg= add_an_arg(&argv, new_arg());
					cmdarg->name= strcatdup(evalstr, file->fname);
				}
			}
		
		else if(eval==FATAL)
		{	/* erreur d'evaluation */
			printf("fmake: can't eval arg `%s`\n" \
			       "       can't exec command '%s'\n", arg->name, cmdpath);
			free_arg(argv);
			*envcut= NULL;
			return FATAL;
		}

		else if(eval==EVAL_DONE && *evalstr!='>')
		{	/* ajoute un parametre  la ligne de commande */
			cmdarg= add_an_arg(&argv, new_arg());
			cmdarg->name= strdup(evalstr);
		}
		
		/* valeur de l'argument */
		eval= eval_arg(arg->value, evalstr, target->env);

		if(io_redir)
		{
			ext= strchr(evalstr, '.');
			if(ext) ext= strdup(ext);
			
			if(eval==TARGET)
				strcat(stdoutpath, basename(target->fname));
			else if(eval==SOURCE)
				strcat(stdoutpath, basename(source->fname));
				
			if(ext)
			{
				set_ext(ext, basename(stdoutpath));
				free(ext);
			}
			io_redir= 0;
		}

		else if(eval==TARGET && cmdarg)
			/* ajoute la cible */
			cmdarg->value= strcatdup(evalstr, target->fname);

		else if(eval==SOURCE)
			/* ajoute le source */
			cmdarg->value= strcatdup(evalstr, source->fname);

		else if(eval==ALL)
		{	/* ajoute tous les sources */
			cmdarg->value= strcatdup(evalstr, source->fname);
			for(file= source->next; file; file= file->next)
			{
				if(!file->dependency)
				{
					cmdarg= add_an_arg(&argv, new_arg());
					cmdarg->name= strcatdup(evalstr, file->fname);
				}
			}
		}
		
		else if(eval==FATAL)
		{	/* erreur d'evaluation */
			printf("fmake: can't eval value of argument `%s`\n" \
			       "       can't exec command '%s'\n", arg->name, cmdpath);
			free_arg(argv);
			*envcut= NULL;
			return FATAL;
		}

		else if(eval==EVAL_DONE)
			/* ajoute un parametre  la ligne de commande */
			cmdarg->value= strdup(evalstr);
	}

	/* construit la ligne de commande */
	cmdstr= set_cmdstr(argv);
	/* printf("cmd line %s\n", cmdstr +2); */

	/* construit la chaine d'environnement */
	envstr= set_cmdenv(target->env, cmdstr);
	
	/* supprime l'environnement tos */
	*envcut= NULL;

	/* redirige stdout */
	set_stdout(stdoutpath);
	 
	/* appelle la commande */
	eval= Pexec(0, cmdpath, cmdstr+1, envstr);
	
	/* retourne  l'ecran standard */
	reset_stdout();
	
	/* printf("return status: %d\n", eval); */
	/* if(eval)
		printf("there are errors, return status: %d\n", eval); */
	
	/* libere la memoire */
	free_arg(argv);
	free(cmdstr);
	free(envstr);
		
	return eval;
}
