/*
	tools.h
	
	defines for tools.c

	T.AL 95
*/

#if !defined(TOOLS_H)
#define TOOLS_H

#if !defined(FMAKE_H)
#include "fmake.h"
#endif

#define MAXBUF 1024

CMD *new_cmd(void);
int free_cmd(CMD *cmd);
CMD *add_cmd(File *file, CMD *new);

File *new_file(void);
int free_file(File *file);
File *add_file(File **file, File *new);
File *append_flist(File **file, File *new);

ARG *new_arg(void);
int free_arg(ARG *arg);
ARG *add_an_arg(ARG **argv, ARG *new);
ARG *add_arg(CMD *cmd, ARG *new);

VAR *new_var(void);
int free_var(VAR *var);
VAR *add_a_var(VAR **env, VAR *var);
VAR *add_var(File *cmd, VAR *var);
VAR **add_an_env(VAR *old, VAR *new);

void alert(char *msg, ...);

int datecmp(File_Date *a, File_Date *b);
File_Date *datecpy(File_Date *dst, File_Date *src);
File_Date *datemax(File_Date *a, File_Date *b);

void set_time(File_Date *time, unsigned int int_ftime);
void set_date(File_Date *date, unsigned int int_fdate);
void set_file_dtm(File *file);

int init_parser(int prj_file);
int read_a_char(void);
char *get_token(void);
char *get_crtoken(void);

int (*find_type(char c))(char);
int (*find_crtype(char c))(char);

int is_fname(char *tok);
int is_ext(char *tok);
int is_option(char *tok);
int is_var(char *tok);

int is_opnacc(char *tok);
int is_clsacc(char *tok);
int is_opnpar(char *tok);
int is_clspar(char *tok);
int is_equal(char *tok);
int is_cr(char *tok);

int is_a_char(char c);
int is_a_alpha(char c);
int is_a_crspace(char c);
int is_a_space(char c);
int is_a_option(char c);
int is_a_str(char c);
int is_a_cr(char c);
int is_a_equal(char c);
int is_a_separator(char c);

void get_tosenv(void);

char *filename(char *path, char *basename, char *ext);
void splitfilename(char *filename, char **path, char **basename, char **ext);
char *basename(char *path);
char *getext(char *fname);
char *set_ext(char *ext, char *fname);

char *strvar(char *str);
char *strcatdup(char *str1, char *str2);
char *vstrcatdup(char *format, ...);
char *strndup(char *str, int n);


#endif
