/*
	ttpmain.c
	
	an F project manager
	ttp version
	
	T.AL 95
*/
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <tos.h>

#if !defined(FMAKE_H)
#include "fmake.h"
#endif
#if !defined(TOOLS_H)
#include "tools.h"
#endif

int main(int argc, char *argv[])
{
	int arg;
	int clean= 0, build= 0;
	int status;
	char *opt, *str;
	char makefile[256]= "";

	/* setting defaults */
	Make_All= 0;
	Make_Stop= STOP_FIRST;

	*Make_Logpath= 0;
	*Make_Logbasename= 0;
	*Make_Logext= 0;
	Make_Logsinglefile= 0;
	
	/* install DTA for Fsfirst/next */
	Fsetdta(&Dta);
	
	/* banner */
	printf("FMAKE 0.5a\t\t\t(c) T.AL 95\n" \
	       "version compiled " __DATE__ " " __TIME__ "\n\n" \
	       "try `fmake help` to get helped?!\n\n");

	/*  command line parsing */
	for(arg= 1; arg<argc; arg++)
	{
		opt= strlwr(argv[arg]);

		if(strcmp(opt, "help")==0 || strcmp(opt, "h")==0)
		{
			alert(
		      "usage: fmake makefile[.fmk] [cmd]\n\n" \

		      "   with [cmd]:\n" \
		      "       [u]pdate : updates default makefile\n" \
		      "       [a]ll : building of all targets\n" \
		      "       [c]lean : clearing of all targets\n" \
		      "       [b]uild file : building of 'file' and its dependancy files\n" \
		      "       [e]rrors [path][basename].ext : error messages are put in the\n" \
		      "           file-specification. If no basename is given #target is assumed.\n" \
		      "       [s]top + : stops after the first building error\n" \
		      "       [s]top - : updates the complete makefile\n\n" \
		      
		      "   Makefile file extension may be omitted.\n" \
		      "   If makefile is omitted then fmake scans the current directory to find\n" \
		      "   a single one.\n"		      
			);		
		}
		
		else if(strcmp(opt, "update")==0 || strcmp(opt, "u")==0)
		{
			; /* nothing special to do */
		}

		else if(strcmp(opt, "build")==0 || strcmp(opt, "b")==0)
		{	/* make all */
			if(++arg<argc)
				opt= strlwr(argv[arg]);
			else
				alert("fmake: missing `build` argument\n");
			
			strcpy(Make_Buildfilespec, opt);
			build= 1;
		}

		else if(strcmp(opt, "all")==0 || strcmp(opt, "a")==0)
		{	/* make all */
			Make_All= 1;
		}
		
		else if(strcmp(opt, "clean")==0 || strcmp(opt, "c")==0)
		{	/* make clean */
			clean= 1;
		}
		
		else if(strcmp(opt, "errors")==0 || strcmp(opt, "e")==0)
		{	/* errors */
			
			if(++arg<argc)
				opt= strlwr(argv[arg]);
			else
				alert("fmake: missing `errors` arguments\n");
			
			if(is_fname(opt))
				strcpy(Make_Logpath, opt);
			
			else if(is_ext(opt))
				strcpy(Make_Logext, opt);
			
			else 
				alert("fmake: 'errors' argument must be `[path\][basename].ext`\n");
			
			if(*Make_Logpath)
			{
				str= basename(Make_Logpath);
				if(is_ext(str))
				{
					printf("Warning: logfile `%s`, #target basename assumed\n", Make_Logpath);
					strcpy(Make_Logbasename, "#target");
					strcpy(Make_Logext, str);
					*str= 0;
				}
				else if(is_fname(str))
				{
					Make_Logsinglefile= 1;
					strcpy(Make_Logbasename, str);
					*str= 0;
					str= getext(Make_Logbasename);
					if(str)
					{
						strcpy(Make_Logext, str);
						*str= 0;
					}
					else
					{
						strcpy(Make_Logext, ".err");
						printf("Warning: logfile `%s`, `%s` file extension assumed\n", Make_Logbasename, Make_Logext);
					}
				}
			}
			
			else if(*Make_Logext)
			{
				printf("Warning: logfile `%s`, #target basename assumed\n", Make_Logext);
				strcpy(Make_Logbasename, "#target");
			}
		}
		
		else if(strcmp(opt, "stop")==0 || strcmp(opt, "s")==0)
		{	/* stop */
			
			if(++arg<argc)
				opt= strlwr(argv[arg]);
			else
				alert("fmake: missing `stop` argument\n");
			
			if(*opt=='+')
				Make_Stop= STOP_FIRST;
			
			else if(*opt=='-')
				Make_Stop= STOP_NEVER;
			
			else 
				alert("fmake: 'stop' argument must be +|-\n");
		}
				
		else if(is_fname(opt))
		{	/* makefile */
			if(*makefile)
				alert("fmake: found several makefile specifications\n  `%s`\n  `%s`\n", makefile, opt);
				
			strcpy(makefile, opt);
			/* force l'extension */
			if(!getext(makefile))
				set_ext(".fmk", makefile);
		}

		else
			alert("fmake: unknown argument `%s`\n", opt);
	}

	/* verifie la coherence des commandes */
	if(!*makefile)
	{
		printf("Warning: no makefile specification found, searching default makefile\n");
		status= Fsfirst("*.fmk", 0);
		if(!status)
			alert("fmake: no default *.fmk makefile found\n");		
		strcpy(makefile, Dta.d_fname);
		status= Fsnext();
		if(!status)
			alert("fmake: found several makefiles, no default assumed\n");
	}
	
	if(Make_All && clean)
	{
		printf("Warning: `all` and `clean` switches on, `all` switch assumed\n\n");
		clean= 0;
	}

	/* execute les commandes */	
	if(clean)
		status= make_clean(makefile);

	else if(build)
		status= make_file(makefile);
	
	else
		status= make(makefile);
		
	getch();
	return status;
}